// Code generated by "enumer -type=PropertyType -json -text -yaml -sql"; DO NOT EDIT.

//
package propertyValueTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _PropertyTypeName = "BooleanFloatIntStringStringMapStringStringSlice"

var _PropertyTypeIndex = [...]uint8{0, 7, 12, 15, 21, 36, 47}

func (i PropertyType) String() string {
	if i < 0 || i >= PropertyType(len(_PropertyTypeIndex)-1) {
		return fmt.Sprintf("PropertyType(%d)", i)
	}
	return _PropertyTypeName[_PropertyTypeIndex[i]:_PropertyTypeIndex[i+1]]
}

var _PropertyTypeValues = []PropertyType{0, 1, 2, 3, 4, 5}

var _PropertyTypeNameToValueMap = map[string]PropertyType{
	_PropertyTypeName[0:7]:   0,
	_PropertyTypeName[7:12]:  1,
	_PropertyTypeName[12:15]: 2,
	_PropertyTypeName[15:21]: 3,
	_PropertyTypeName[21:36]: 4,
	_PropertyTypeName[36:47]: 5,
}

// PropertyTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func PropertyTypeString(s string) (PropertyType, error) {
	if val, ok := _PropertyTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to PropertyType values", s)
}

// PropertyTypeValues returns all values of the enum
func PropertyTypeValues() []PropertyType {
	return _PropertyTypeValues
}

// IsAPropertyType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i PropertyType) IsAPropertyType() bool {
	for _, v := range _PropertyTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for PropertyType
func (i PropertyType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for PropertyType
func (i *PropertyType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("PropertyType should be a string, got %s", data)
	}

	var err error
	*i, err = PropertyTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for PropertyType
func (i PropertyType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for PropertyType
func (i *PropertyType) UnmarshalText(text []byte) error {
	var err error
	*i, err = PropertyTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for PropertyType
func (i PropertyType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for PropertyType
func (i *PropertyType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = PropertyTypeString(s)
	return err
}

func (i PropertyType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *PropertyType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := PropertyTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
